package name.panitz.parser;

import static org.junit.Assert.*;

import java.lang.reflect.Method;
import java.lang.reflect.Modifier;

import org.junit.Before;
import org.junit.Test;
import java.util.List;
import java.util.ArrayList;
import java.io.File;
import java.util.Map;

import static name.panitz.parser.Parser.*;

public class Parser2Test {
  LTokenizer tok = null;
  @Before
  public void setUp() throws Exception {
    tok = new LTokenizer();
  }

  int tt(String prog){  
    tok.setInputString(prog);
    return new Eval().eval(Parser.program().get().parse(tok.asList()).get(0).result()) ;
  }
  @Test
  public void test1() {
    assertEquals(42,tt("42"));
  }
  @Test
  public void test2() {
    assertEquals(25,tt("17+4*2"));
  }
  @Test
  public void test3() {
    assertEquals(1,tt("(17+4)*2 = 42"));
  }

  @Test
  public void test4() {
    assertEquals(42,tt("45-1-1-1"));
  }

  @Test
  public void test5() {
    assertEquals(42,tt("{x:=20;r:=2;(2*20+2)}"));
  }
  @Test
  public void test6() {
    assertEquals(120,tt("{x:=5;r:=1;while (if x=0 then 0 else 1 ){r:=x*r;x:=x-1};r}"));
  }
  @Test
  public void test7() {
    assertEquals(175,tt("fun fac(n)={r:=1;while (if n=0 then 0 else 1){r:=n*r;n:=n-1};r}  fun fib(n)=if n=0 then 0 else if n=1 then 1 else fib(n-2)+fib(n-1) fac(5)+fib(10)"));
  }
}