package name.panitz.parser;

import static org.junit.Assert.*;

import java.lang.reflect.Method;
import java.lang.reflect.Modifier;

import org.junit.Before;
import org.junit.Test;
import java.util.List;
import java.util.ArrayList;
import java.io.File;
import java.util.Map;

import static name.panitz.parser.Parser.*;

public class ParserTest {
  LTokenizer tok = null;
  @Before
  public void setUp() throws Exception {
    tok = new LTokenizer();
  }

  @Test
  public void test1() {
    tok.setInputString("42");
    assertEquals(new Result<>(List.of(),new Prog(List.of(),new IntLiteral(42)))
                ,Parser.program().get().parse(tok.asList()).get(0));
  }

  @Test
  public void test2() {
    tok.setInputString("17+4*2");
    assertEquals(List.of()
                ,Parser.program().get().parse(tok.asList()).get(0).rest());
  }

  @Test
  public void test3() {
    tok.setInputString("(17+4)*2 = 42");
    assertEquals(List.of()
                ,Parser.program().get().parse(tok.asList()).get(0).rest());
  }

  @Test
  public void test4() {
    tok.setInputString("{x:=5;r:=1;while (if x=0 then 0 else 1){r:=x*r;x:=x-1};r}");
    assertEquals(List.of()
                ,Parser.program().get().parse(tok.asList()).get(0).rest());
  }

  @Test
  public void test5() {
    tok.setInputString("fun fac(n)=if x=0 then 1 else n*(n-1)  fac(5)");
    assertEquals(List.of()
                ,Parser.program().get().parse(tok.asList()).get(0).rest());
  }

  @Test
  public void test6() {
    tok.setInputString("fun fac(n)={r:=1;while (if n=0 then 0 else 1){r:=n*r;x:=x-1};r}  fun fib(n)=if n=0 then 0 else if n=1 then 1 else fib(n-2)+fib(n-1) fac(5)+fib(10)");
    assertEquals(List.of()
                ,Parser.program().get().parse(tok.asList()).get(0).rest());
  }
}